"""
Wendland W33 compactly supported Radial Basis function class.  The functions
are positive definite in dimensions d <= 3 and have C6 smoothness.

import suggestion: from W33 import *

"""

from rbfCompactClass import rbfc

class W33(rbfc):

	def rbf(self,r,s):
		r = r/s
		return self.pPlus(r,8)*(1 + 8*r + 25*r**2 + 32*r**3)

	def D1(self, r, s, x):
		r, x = r/s, x/s
		return -(22/s)*x*self.pPlus(r,7)*(1 + 7*r + 16*r**2)
	
	def D2(self, r, s, x):
		r, x = r/s, x/s
		return (22/s**2)*self.pPlus(r,6)*(-1 + 6*r*(24*x**2 - 1) - 9*r**2 + 16*r**3 + 24*x**2)
	
	def D3(self, r, s, x):
		r, x = r/s, x/s
		return 1584*x*(14*x**2*r**5 - 70*x**2*r**4 + 140*x**2*r**3 - 140*x**2*r**2 + 70*x**2*r - 14*x**2 + 6*r**7 - 35*r**6 + 84*r**5 - 105*r**4 + 70*r**3 - 21*r**2 + 1)
	
	def D4(self, r, s, x):
		r, x = r/s, x/s
		return 110880*x**4*r**3 - 443520*x**4*r**2 + 665280*x**4*r - 443520*x**4 + 110880*x**4/r + 133056*x**2*r**5 - 665280*x**2*r**4 + 1330560*x**2*r**3 - 1330560*x**2*r**2 + 665280*x**2*r - 133056*x**2 + 9504*r**7 - 55440*r**6 + 133056*r**5 - 166320*r**4 + 110880*r**3 - 33264*r**2 + 1584
	


