"""
The folder rbfX/centersLib contains text files with the locations of 
centers and evaluation points for various 2d domains.  The function
rbfCentersLib loads the centers from files into  ndarrays.
 
Evaluation points for a domain are numbered as follows:
    if the centers are for example ch = 4, then the evaluation points for 
    the same region are numbered as ch = 401

input
      ch    domain choice
 
output
     x, y   center locations
     bpi   indices of the centers located on the boundary of the domain

suggested import: import rbfCentersLib as cl

"""


import scipy as sp
import matplotlib.pyplot as pp

dir = '/home/sarra/pCloudDrive/suites/p/rbfX/centersLib/'

def rbfCentersLib(ch,plt=False):
	if ch==1:              # "ameoba" shaped domain
		x = sp.loadtxt(dir + 'x2508.txt')
		y = sp.loadtxt(dir + 'y2508.txt')
		bpi = sp.arange(210)
	elif ch==2:            # tilted 8 with a circlular hole
		x = sp.loadtxt(dir + 'x3061.txt')
		y = sp.loadtxt(dir + 'y3061.txt')
		bpi = None                    # FIX THIS
	elif ch==3:            
		x = sp.loadtxt(dir + 'x10204.txt')
		y = sp.loadtxt(dir + 'y10204.txt')
#		bpi = sp.arange(8638,9020)
		bpi = sp.arange(9822,10204)
	elif ch==4:            #
		xc = sp.loadtxt(dir + 'X618.txt')
		x, y = xc[:,0], xc[:,1] 
		bpi = sp.arange(118)
	elif ch==401:          # quarter of a circle evaluation points
		xc = sp.loadtxt(dir + 'X930.txt')
		x, y = xc[:,0], xc[:,1] 
		bpi = None
	
	if plt:
		pp.scatter(x,y,c='g',marker='.')
		if bpi is not None:
			pp.scatter(x[bpi],y[bpi],c='r',marker='.')
		
	return x, y, bpi
		
