"""
Base class for test functions of three variables.

"""


from abc import ABC, abstractmethod

class function3d(ABC):
	
	@abstractmethod
	def F(self,x,y,z): pass      # function definition
	
	@abstractmethod
	def x1(self,x,y,z): pass     # 1st derivative wrt x
	
	@abstractmethod
	def x2(self,x,y,z): pass     # 2nd derivative wrt x
	
	@abstractmethod
	def x3(self,x,y,z): pass     # 3rd derivative wrt x
	
	@abstractmethod
	def x4(self,x,y,z): pass     # 4th derivative wrt x
	
	@abstractmethod
	def y1(self,x,y,z): pass     # 1st derivative wrt y
	
	@abstractmethod
	def y2(self,x,y,z): pass     # 2nd derivative wrt y
	
	@abstractmethod
	def y3(self,x,y,z): pass     # 3rd derivative wrt y
	
	@abstractmethod
	def y4(self,x,y,z): pass     # 4th derivative wrt y
	
	@abstractmethod
	def z1(self,x,y,z): pass     # 1st derivative wrt z
	
	@abstractmethod
	def z2(self,x,y,z): pass     # 2nd derivative wrt z
	
	@abstractmethod
	def z3(self,x,y,z): pass     # 3rd derivative wrt z
	
	@abstractmethod
	def z4(self,x,y,z): pass     # 4th derivative wrt z
	
	@abstractmethod
	def div(self,x,y,z): pass    # divergence f_x + f_y + f_z
	
	@abstractmethod
	def L(self,x,y,z): pass      # Laplacian f_{xx} + f_{yy} + f_{zz}
		
	@abstractmethod
	def B(self,x,y,z): pass      # Biharmonic operator f_{xxxx} + f_{yyyy} + f_{zzzz}  + 2 f_{xxyy} + 2 f_{yyzz} + 2 f_{xxzz}
		

	
	
	
	
	
